package com.engine.qdhx.biz;

import com.cloudstore.dev.api.util.Util_DataCache;
import com.engine.qdhx.entity.Builder;
import com.engine.qdhx.entity.Context;
import com.engine.qdhx.entity.HrmSalaryEntity;
import com.engine.qdhx.service.impl.AddSalaryStrategy;
import com.engine.qdhx.service.impl.DivisionSalaryStrategy;
import com.engine.qdhx.service.impl.MultiplySalaryStrategy;
import com.engine.qdhx.service.impl.SubtractionSalaryStrategy;
import com.engine.qdhx.util.SalaryUtil;
import weaver.conn.RecordSet;
import weaver.conn.RecordSetTrans;
import weaver.general.BaseBean;
import weaver.general.Util;


import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.stream.Collectors;


/**
 * @Author weaver_cl
 * @Description: TODO
 * @Date 2022/2/21
 * @Version V1.0
 **/
public class HrmSalaryDiffReportBiz extends BaseBean {

    private static final double DEFAULTVALUE = 0.00;



    /**
     * 获取薪资报表数据
     * @param fromDate
     * @param toDate
     * @param subCompanyId
     * @param departmentId
     * @param resourceId
     * @return
     */
    public List getScheduleList(String fromDate, String toDate, String subCompanyId, String departmentId, String resourceId) throws Exception {

        List<HrmSalaryEntity> hrmSalaryList = new ArrayList<>();
        List<List<Object>> taxRateList = new LinkedList<>(); //居民税率台账
        List<List<Object>> taxRateNRList = new LinkedList<>(); //非居民税率台账
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();
        Util_DataCache dataCache = new Util_DataCache();
        HrmTaxDiffBiz hrmTaxDiffBiz = new HrmTaxDiffBiz();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyyMM");
        LocalDate start = LocalDate.parse(fromDate, DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        String xzszny = formatter.format(start);

        //String sameDay = SalaryUtil.getSameDay(fromDate);

        String sqlwhere = "SELECT\n" +
                " a.id,\n" +
                " a.lastname,\n" +
                " a.subcompanyid1,\n" +
                " a.departmentid,\n" +
                " a.workcode,\n" +
                " a.birthday,\n" +
                " a.companystartdate,\n" +
                " a.status,\n" +
                " a.dismissdate\n" +
                " FROM\n" +
                " hrmresource a\n" +
                "WHERE\n" +
                " (a.status < 4 or\n" +
                " (a.status >= 4 and\n" +
                " a.DISMISSDATE > '"+fromDate+"'))";

        //String sqlwhere = "select id,lastname,subcompanyid1,departmentid,workcode,birthday,companystartdate,status from hrmresource where 1=1 ";
        Map<String, String> params = new HashMap<>();
        params.put("subcompanyid1",subCompanyId);
        params.put("departmentid",departmentId);
        params.put("id",resourceId);
        //加班数据
        Map flowData = SalaryUtil.getFlowOverTimeDataNew(fromDate, toDate, params);
        Map lastFlowData = SalaryUtil.getLastFlowOverTimeData(fromDate, toDate, params);

        //请假数据
        Map<String, String> flowLeaveData = SalaryUtil.getFlowLeaveData(fromDate, toDate, params);

        boolean judgeHoliday = SalaryUtil.judgeHoliday(fromDate, toDate);

        //if (rs.getDBType().equalsIgnoreCase("sqlserver")){
        Map<String, String> collect = params.entrySet().stream()
                .filter(map -> !"".equals(map.getValue()))
                .collect(Collectors.toMap(p -> p.getKey(), p -> p.getValue()));

        for (String key : collect.keySet()) {
            sqlwhere += " and a."+key+" = "+collect.get(key);
        }
        //}

        rs.executeQuery(sqlwhere);

        while (rs.next()){
            String resourceid = Util.null2String(rs.getString("id"));
            int status = Util.getIntValue(rs.getString("status"));
            String place = SalaryUtil.getPlaceById(resourceid);
            String departmentid = Util.null2String(rs.getString("departmentid"));
            String costcode = SalaryUtil.getCostcodeById(resourceid);
            String workcode = Util.null2String(rs.getString("workcode"));

            String companystartdate = Util.null2String(rs.getString("companystartdate"));
            String dismissdate = Util.null2String(rs.getString("dismissdate"));


            String taxid = SalaryUtil.getTaxidById(resourceid);

            Map<String,Double> welfareMap = SalaryUtil.welfareTable(workcode);
            Map<String,Double> bonusMap = SalaryUtil.bonusTable(workcode);
            Map<String,Double> reduceMap = SalaryUtil.reduceTable(workcode);
            Map<String,Double> kqMap = SalaryUtil.getKqInfo(fromDate,toDate,resourceid);
            Map<String,Double> ipMap = SalaryUtil.getInsuranceAndProvident(workcode, xzszny);


            Context context = new Context();
            context.setSalaryStrategy(new AddSalaryStrategy());

            //中国农业银行账户
            String bankAccount = SalaryUtil.getBankAccount(resourceid);

            //薪资项目
            double basicSalary = SalaryUtil.getBasicSalary(resourceid);
            double overtimePay = SalaryUtil.getOvertimePay(resourceid);

            //本月
            double workingDayOvertime_nonleave = SalaryUtil.getDoubleValue(Util.null2String(flowData.get(resourceid+"|workingDayOvertime_nonleave")),0.00);
            double restDayOvertime_nonleave = SalaryUtil.getDoubleValue(Util.null2String(flowData.get(resourceid+"|restDayOvertime_nonleave")),0.00);
            double holidayOvertime__nonleave = SalaryUtil.getDoubleValue(Util.null2String(flowData.get(resourceid+"|holidayOvertime__nonleave")),0.00);

            //上个月
            double workingDayOvertime_nonleave_last = SalaryUtil.getDoubleValue(Util.null2String(lastFlowData.get(resourceid+"|workingDayOvertime_nonleave")),0.00);
            double restDayOvertime_nonleave_last = SalaryUtil.getDoubleValue(Util.null2String(lastFlowData.get(resourceid+"|restDayOvertime_nonleave")),0.00);
            double holidayOvertime__nonleave_last = SalaryUtil.getDoubleValue(Util.null2String(lastFlowData.get(resourceid+"|holidayOvertime__nonleave")),0.00);

            double overtimePayG1 = SalaryUtil.overTimeWorkMoney(basicSalary,String.valueOf(context.execute(workingDayOvertime_nonleave,workingDayOvertime_nonleave_last)),"1.5");
            double overtimePayG2 = SalaryUtil.overTimeWorkMoney(basicSalary,String.valueOf(context.execute(restDayOvertime_nonleave,restDayOvertime_nonleave_last)),"2");
            double overtimePayG3 = SalaryUtil.overTimeWorkMoney(basicSalary,String.valueOf(context.execute(holidayOvertime__nonleave,holidayOvertime__nonleave_last)),"3");



            //福利项目
            String birthday = Util.null2String(rs.getString("birthday"));
            double birthdayCashgift = DEFAULTVALUE;
            if (status < 4 && SalaryUtil.dateInterval(fromDate,toDate,birthday) && SalaryUtil.localDateIsBefore(birthday,companystartdate)){
                birthdayCashgift =  welfareMap.getOrDefault("birthdayCashgift",0.00);
            }else if(status > 4 ) {
                if (SalaryUtil.dateInterval(fromDate,toDate,dismissdate) && SalaryUtil.localDateIsBefore(dismissdate,birthday)) {
                    birthdayCashgift =  welfareMap.getOrDefault("birthdayCashgift",0.00);
                }
            }

            double merryCashgift = welfareMap.getOrDefault("merryCashgift",0.00);
            double funeralCashgift = welfareMap.getOrDefault("funeralCashgift",0.00);
            double festivalCashgift = DEFAULTVALUE;
            if (status < 4 && judgeHoliday ) {
                festivalCashgift = welfareMap.getOrDefault("festivalCashgift",0.00);
            }

            int monthValue = start.getMonthValue();
            boolean flag = SalaryUtil.dateInterval(fromDate,toDate,companystartdate);
            double preventHeatAllowance = DEFAULTVALUE; //防暑补贴
            double highTemperatureSubsidy = DEFAULTVALUE; //高温补贴
            if (monthValue >= 6 && monthValue <= 9) {
                preventHeatAllowance = welfareMap.getOrDefault("preventHeatAllowance",0.00);
                highTemperatureSubsidy = welfareMap.getOrDefault("highTemperatureSubsidy",0.00);
                if (flag || status >= 4) {
                    preventHeatAllowance = SalaryUtil.heatAndTemperatureAllowance(kqMap.getOrDefault("attendancedays",0.00),preventHeatAllowance);
                    highTemperatureSubsidy = SalaryUtil.heatAndTemperatureAllowance(kqMap.getOrDefault("attendancedays",0.00),highTemperatureSubsidy);
                }
            }

            double communicatySubsidy = welfareMap.getOrDefault("communicatySubsidy",0.00);
            double shiftAllowance = welfareMap.getOrDefault("shiftAllowance",0.00); //轮班补贴
            double standAllowance = welfareMap.getOrDefault("standAllowance",0.00);
            double achievementonus = welfareMap.getOrDefault("achievementonus",0.00);
            double abroadInsuranceSubsidy = welfareMap.getOrDefault("abroadInsuranceSubsidy",0.00);
            double otherItem1 = welfareMap.getOrDefault("otherItem1",0.00);
            double otherItem2 = welfareMap.getOrDefault("otherItem2",0.00);
            double houseSubsidy = welfareMap.getOrDefault("houseSubsidy",0.00);

            double welfareSum = context.execute(birthdayCashgift,merryCashgift,funeralCashgift,festivalCashgift,
                    preventHeatAllowance,highTemperatureSubsidy,communicatySubsidy,shiftAllowance,standAllowance,
                    achievementonus,abroadInsuranceSubsidy,otherItem1,houseSubsidy);

            //奖金
            double specialAward = bonusMap.getOrDefault("specialAward",0.00);
            double signMoney = bonusMap.getOrDefault("signMoney",0.00);
            double meritsPay = bonusMap.getOrDefault("meritsPay",0.00);
            double annualBonus = bonusMap.getOrDefault("annualBonus",0.00);
            double ompensation = bonusMap.getOrDefault("ompensation",0.00);

            double awardSum = context.execute(specialAward,signMoney,meritsPay,annualBonus);

            //扣除项
            double otherDeduction = reduceMap.getOrDefault("otherDeduction",0.00);
            double costWithhold = reduceMap.getOrDefault("costWithhold",0.00);
            double mealWithhold = reduceMap.getOrDefault("mealWithhold",0.00);

            //考勤扣款
            Double workdays = kqMap.getOrDefault("workdays",0.00);
            Double attendancedays = kqMap.getOrDefault("attendancedays",0.00);
            if (workdays > attendancedays) {
                //attendancedays = context.execute(attendancedays,SalaryUtil.conversionLeave(flowLeaveData,resourceid));
                //实际出勤天数 += 请假归档数据换算 + （旷工天数-迟到早退天数 ）
                attendancedays = context.execute(attendancedays,
                        SalaryUtil.conversionLeave(flowLeaveData,resourceid),kqMap.getOrDefault("leavedays",0.00));
            }

            double salaryMoney = context.execute(basicSalary,overtimePay);
            //判断是否当月入职离职人员
            if (SalaryUtil.dateInterval(fromDate,toDate,companystartdate) || SalaryUtil.dateInterval(fromDate,toDate,dismissdate)) {
                Context contextTest = new Context();
                contextTest.setSalaryStrategy(new DivisionSalaryStrategy());
                double money = contextTest.execute(salaryMoney, 21.75);
                contextTest.setSalaryStrategy(new MultiplySalaryStrategy());
                salaryMoney = contextTest.execute(money,workdays);
            }

            double attendanceDeduction = attendancedays > 0 ? SalaryUtil.attendanceDeduction(salaryMoney,workdays,attendancedays):salaryMoney;
            double salarySum = context.execute(salaryMoney,overtimePayG1,overtimePayG2,overtimePayG3);


            double deducteSum = context.execute(otherDeduction,attendanceDeduction);
            double addSum = context.execute(salarySum,welfareSum,awardSum);

            //加上未扣税数据
            double addSumNew = context.execute(addSum,otherItem2,ompensation);

            //应纳税额
            context.setSalaryStrategy(new SubtractionSalaryStrategy());
            double taxable = context.execute(addSum,deducteSum);

            //应发总额
            double shouldSendTotal = context.execute(addSumNew, deducteSum);
            double endowmentInsurance = ipMap.getOrDefault("ylgr16",0.00); //养老保险

            double medicalInsurance = ipMap.getOrDefault("ylgr2",0.00); //医疗保险

            double unemploymentInsurance = ipMap.getOrDefault("sygr03",0.00); //失业保险

            double houseProvident = ipMap.getOrDefault("gjjgr5",0.00); //住房公积金

            //个税计算
            double dndividualIncomeTax = 0;
            //bb.writeLog(String.format("taxId: %s || resourceid:%s",taxid,resourceid));
            if("0".equals(taxid)){
                Map<String, List<Object>> taxToDosByJm = hrmTaxDiffBiz.getTaxToDosByJm(fromDate, resourceid, workcode, taxable,ipMap);
                if (taxToDosByJm.get("taxRate").size()>0){
                    dndividualIncomeTax = (Double) taxToDosByJm.get("taxRate").get(24);
                    dndividualIncomeTax = dndividualIncomeTax<0?0:dndividualIncomeTax;
                    taxRateList.add(taxToDosByJm.get("taxRate"));
                }
            }else if("1".equals(taxid)){
                Map<String, List<Object>> taxToDosByFjm = hrmTaxDiffBiz.getTaxToDosByFjm(fromDate, resourceid, workcode, taxable, ipMap);
                if(taxToDosByFjm.get("taxRateNR").size()>0){
                    dndividualIncomeTax = (Double) taxToDosByFjm.get("taxRateNR").get(14);
                    dndividualIncomeTax = dndividualIncomeTax<0?0:dndividualIncomeTax;
                    taxRateNRList.add(taxToDosByFjm.get("taxRateNR"));
                }

            }

            //实发总额
            double actuallySendTotal = context.execute(shouldSendTotal,costWithhold,mealWithhold,endowmentInsurance,
                    medicalInsurance,unemploymentInsurance,houseProvident,dndividualIncomeTax);

            HrmSalaryEntity hrmSalaryEntity = Builder.of(HrmSalaryEntity::new)
                    .with(HrmSalaryEntity::setPlace, place)
                    .with(HrmSalaryEntity::setDeptId, departmentid)
                    .with(HrmSalaryEntity::setCostcode, costcode)
                    .with(HrmSalaryEntity::setWorkcode, workcode)
                    .with(HrmSalaryEntity::setUserid, resourceid)
                    .with(HrmSalaryEntity::setCompanystartdate, companystartdate)
                    .with(HrmSalaryEntity::setDismissdate, dismissdate)
                    .with(HrmSalaryEntity::setBankAccount, bankAccount)
                    .with(HrmSalaryEntity::setTaxId, taxid)
                    .with(HrmSalaryEntity::setRealBasicSalary, basicSalary)
                    .with(HrmSalaryEntity::setRealOvertimePay, overtimePay)
                    .with(HrmSalaryEntity::setOvertimePayG1, overtimePayG1)
                    .with(HrmSalaryEntity::setOvertimePayG2, overtimePayG2)
                    .with(HrmSalaryEntity::setOvertimePayG3, overtimePayG3)
                    .with(HrmSalaryEntity::setBirthdayCashgift, birthdayCashgift)
                    .with(HrmSalaryEntity::setMerryCashgift, merryCashgift)
                    .with(HrmSalaryEntity::setFuneralCashgift, funeralCashgift)
                    .with(HrmSalaryEntity::setFestivalCashgift, festivalCashgift)
                    .with(HrmSalaryEntity::setPreventHeatAllowance, preventHeatAllowance)
                    .with(HrmSalaryEntity::setHighTemperatureSubsidy, highTemperatureSubsidy)
                    .with(HrmSalaryEntity::setCommunicatySubsidy, communicatySubsidy)
                    .with(HrmSalaryEntity::setShiftAllowance, shiftAllowance)
                    .with(HrmSalaryEntity::setStandAllowance, standAllowance)
                    .with(HrmSalaryEntity::setAchievementonus, achievementonus)
                    .with(HrmSalaryEntity::setAbroadInsuranceSubsidy, abroadInsuranceSubsidy)
                    .with(HrmSalaryEntity::setOtherItem1, otherItem1)
                    .with(HrmSalaryEntity::setOtherItem2, otherItem2)
                    .with(HrmSalaryEntity::setHouseSubsidy, houseSubsidy)
                    .with(HrmSalaryEntity::setSpecialAward, specialAward)
                    .with(HrmSalaryEntity::setSignMoney, signMoney)
                    .with(HrmSalaryEntity::setMeritsPay, meritsPay)
                    .with(HrmSalaryEntity::setAnnualBonus, annualBonus)
                    .with(HrmSalaryEntity::setOmpensation, ompensation)
                    .with(HrmSalaryEntity::setAttendanceDeduction, attendanceDeduction)
                    .with(HrmSalaryEntity::setOtherDeduction, otherDeduction)
                    .with(HrmSalaryEntity::setShouldSendTotal, shouldSendTotal)
                    .with(HrmSalaryEntity::setTaxable,taxable)
                    .with(HrmSalaryEntity::setCostWithhold, costWithhold)
                    .with(HrmSalaryEntity::setMealWithhold, mealWithhold)
                    .with(HrmSalaryEntity::setEndowmentInsurance, endowmentInsurance)
                    .with(HrmSalaryEntity::setMedicalInsurance, medicalInsurance)
                    .with(HrmSalaryEntity::setUnemploymentInsurance, unemploymentInsurance)
                    .with(HrmSalaryEntity::setHouseProvident, houseProvident)
                    .with(HrmSalaryEntity::setIndividualIncomeTax, dndividualIncomeTax)
                    .with(HrmSalaryEntity::setActuallySendTotal, actuallySendTotal)
                    .build();

            hrmSalaryList.add(hrmSalaryEntity);
        }

        //保存税率台账
        saveTaxTable(taxRateList,xzszny);
        saveTaxTableNoR(taxRateNRList,xzszny);

        //缓存记录工作报表
        dataCache.setObjValWithEh("salaryScheduleList",hrmSalaryList);


        return  hrmSalaryList;
    }

    /**
     * 保存税率台账居民
     * @param list
     * @param xzszny
     */
    public void saveTaxTable(List<List<Object>> list,String xzszny){
        RecordSetTrans rst = new RecordSetTrans();
        try {
            rst.setAutoCommit(false);

            rst.executeQuery("select count(1) as count from uf_grsds where xzszny = ?",xzszny);
            rst.next();
            int count = Util.getIntValue(rst.getString("count"));
            if (count > 0) return;
            rst.executeBatchSql("insert into uf_grsds(xm,gh,xzszny,yfze,\n" +
                    "  gjgdtyjmje,gsqzd,sb,gjj,zxfjkc,yfqddqtkc,ynssd,ljsr,ljmssrgjtyjmje,ljjcfy,\n" +
                    "  ljzxkcsb,ljzxkcgjj,ljzxfjkc,ljyfqddqtkc,ljykyjynssde,sl,sskcs,ljjmsecjr80s,ljyykyjse,bqyykyjse,bqyykyjsedyyj,formmodeid) " +
                    " values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",list);

            rst.commit();
        }catch (Exception e) {
            rst.rollback();
            e.printStackTrace();
        }
    }

    /**
     * 保存税率台账非居民
     * @param list
     * @param xzszny
     */
    public void saveTaxTableNoR(List<List<Object>> list,String xzszny){
        RecordSetTrans rst = new RecordSetTrans();
        try {
            rst.setAutoCommit(false);

            rst.executeQuery("select count(1) as count from uf_grsds_fjm where xzszny = ?",xzszny);
            rst.next();
            int count = Util.getIntValue(rst.getString("count"));
            if (count > 0) return;
            rst.executeBatchSql("insert into uf_grsds_fjm(xm,gh,xzszny,yfgz,\n" +
                    "  jbylbxj,zfgjj,qtmssd,yssre,\n" +
                    "  fykcbz,ynssde,sl,sskcs,ynse,jmse,sjynse,shyx,formmodeid) " +
                    " values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",list);

            rst.commit();
        }catch (Exception e) {
            rst.rollback();
            e.printStackTrace();
        }
    }

}
