package com.engine.qdhx.cmd;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.qdhx.biz.HrmSalaryDiffReportBiz;
import com.engine.qdhx.entity.HrmSalaryEntity;
import com.engine.qdhx.util.SalaryUtil;
import org.slf4j.Logger;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.report.schedulediff.HrmScheduleDiffManager;
import weaver.hrm.resource.ResourceComInfo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * @Author weaver_cl
 * @Description: TODO
 * @Date 2022/2/16
 * @Version V1.0
 **/
public class HrmSalaryDiffReportCmd extends AbstractCommonCommand<Map<String,Object>> {


    public HrmSalaryDiffReportCmd(User user, Map<String,Object> params) {
        this.user = user;
        this.params = params;
    }


    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> apidatas = new HashMap<>();

        if (null == user){
            apidatas.put("hasRight", false);
            return apidatas;
        }

        try {
            Map<String,Object> reportdata = new HashMap<>();
            ResourceComInfo resourceComInfo = new ResourceComInfo();
            DepartmentComInfo departmentComInfo = new DepartmentComInfo();

            String typeselect = Util.null2String(params.get("typeselect")); //时间范围
            String viewscope = Util.null2String(params.get("viewscope")); //查看范围
            String subCompanyId = Util.null2String(params.get("subCompanyId"));
            String departmentId = Util.null2String(params.get("departmentId"));
            String resourceId = Util.null2String(params.get("resourceId"));

            String fromDate = "";
            String toDate = "";

            if ("1".equals(typeselect) || "".equals(typeselect)) {
                fromDate = TimeUtil.getLastMonthBeginDay();
                toDate = TimeUtil.getLastMonthEndDay();
            }else {
                fromDate = TimeUtil.getMonthBeginDay();
                toDate = TimeUtil.getMonthEndDay();
            }



            String fileName = fromDate+" "+ "至"+" "+toDate+" "+"薪资情况统计";

            reportdata.put("title", fileName);
            List<Object> titleRows = new ArrayList<Object>();
            List<Object> titleRow = null;
            Map<String,Object> titleCell = null;

            titleRow = new ArrayList<>();

            List<String> rowlist = Stream.of("处","部","费用代码","工号","姓名","入职日期","离职日期","中国农业银行账户","税务身份").collect(Collectors.toList());

            for (String rowvalue : rowlist) {
                titleCell = new HashMap<>();
                titleCell.put("rowspan", "3");
                titleCell.put("value", rowvalue);
                titleRow.add(titleCell);
            }

            titleCell = new HashMap<>();
            titleCell.put("colspan", "5");
            titleCell.put("rowspan", "1");
            titleCell.put("value", "薪资项目");
            titleRow.add(titleCell);

            titleCell = new HashMap<>();
            titleCell.put("colspan", "14");
            titleCell.put("rowspan", "1");
            titleCell.put("value", "福利项目");
            titleRow.add(titleCell);

            titleCell = new HashMap<>();
            titleCell.put("colspan", "4");
            titleCell.put("rowspan", "1");
            titleCell.put("value", "奖金");
            titleRow.add(titleCell);

            List<String> rowlist1 = Stream.of("一次性补偿金(税后)","考勤扣款(减项)","其他减项","应纳税额","应发总额").collect(Collectors.toList());

            for (String rowvalue : rowlist1) {
                titleCell = new HashMap<>();
                titleCell.put("rowspan", "3");
                titleCell.put("value", rowvalue);
                titleRow.add(titleCell);
            }

            titleCell = new HashMap<>();
            titleCell.put("colspan", "2");
            titleCell.put("rowspan", "1");
            titleCell.put("value", "其他减项");
            titleRow.add(titleCell);

            titleCell = new HashMap<>();
            titleCell.put("colspan", "4");
            titleCell.put("rowspan", "1");
            titleCell.put("value", "五险一金代扣代缴款");
            titleRow.add(titleCell);

            titleCell = new HashMap<>();
            titleCell.put("rowspan", "3");
            titleCell.put("value", "个人所得税");
            titleRow.add(titleCell);

            titleCell = new HashMap<>();
            titleCell.put("rowspan", "3");
            titleCell.put("value", "实发总额");
            titleRow.add(titleCell);
            titleRows.add(titleRow); //第一列


            titleRow = new ArrayList<>();
            List<String> salaryTypelist = Stream.of("实发基本工资","实发固定加班费").collect(Collectors.toList());
            for (String rowvalue : salaryTypelist) {
                titleCell = new HashMap<>();
                titleCell.put("rowspan", "2");
                titleCell.put("value", rowvalue);
                titleRow.add(titleCell);
            }

            titleCell = new HashMap<>();
            titleCell.put("rowspan", "1");
            titleCell.put("colspan", "3");
            titleCell.put("value", "加班费");
            titleRow.add(titleCell);


            List<String> welfareTypelist = Stream.of("生日礼金","结婚礼金","丧葬礼金","节日礼金",
                    "防暑津贴","高温补贴","通讯补贴","轮班津贴","站别津贴","生产绩效奖金","境外保险补贴","其他加项1","其他加项2(税后)","住房补贴").collect(Collectors.toList());
            for (String rowvalue : welfareTypelist) {
                titleCell = new HashMap<>();
                titleCell.put("rowspan", "2");
                titleCell.put("value", rowvalue);
                titleRow.add(titleCell);
            }


            List<String> bonusTypelist = Stream.of("特别奖励金","签约金","绩效奖","年终奖","住宿水电物业费代扣","餐费代扣").collect(Collectors.toList());
            for (String rowvalue : bonusTypelist) {
                titleCell = new HashMap<>();
                titleCell.put("rowspan", "2");
                titleCell.put("value", rowvalue);
                titleRow.add(titleCell);
            }


            List<String> insuranceTypelist = Stream.of("养老保险","医疗保险","失业保险","住房公积金").collect(Collectors.toList());
            for (String rowvalue : insuranceTypelist) {
                titleCell = new HashMap<>();
                titleCell.put("rowspan", "2");
                titleCell.put("value", rowvalue);
                titleRow.add(titleCell);
            }
            titleRows.add(titleRow); //第二列

            titleRow = new ArrayList<>();
            List<String> workTimeTypelist = Stream.of("G1","G2","G3").collect(Collectors.toList());
            for (String rowvalue : workTimeTypelist) {
                titleCell = new HashMap<>();
                titleCell.put("rowspan", "1");
                titleCell.put("value", rowvalue);
                titleRow.add(titleCell);
            }
            titleRows.add(titleRow); //第三列


            reportdata.put("titlerows", titleRows);
            List<Object> datarows = new ArrayList<>();
            List<Object> row = null;
            Map<String,Object> cell = null;
            HrmSalaryDiffReportBiz salaryDiffReportBiz = new HrmSalaryDiffReportBiz();

            List scheduleList = salaryDiffReportBiz.getScheduleList(fromDate,toDate,subCompanyId,departmentId,resourceId);
            HrmSalaryEntity hrmSalaryEntity = null;
            for(int i=0; i<scheduleList.size(); i++) {
                hrmSalaryEntity = (HrmSalaryEntity)scheduleList.get(i);
                row = new ArrayList<>();
                datarows.add(row);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(departmentComInfo.getDepartmentName(hrmSalaryEntity.getPlace())));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(departmentComInfo.getDepartmentName(hrmSalaryEntity.getDeptId())));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getCostcode()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getWorkcode()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(resourceComInfo.getLastname(hrmSalaryEntity.getUserid())));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getCompanystartdate()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getDismissdate()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getBankAccount()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(SalaryUtil.getTaxName(hrmSalaryEntity.getTaxId())));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getRealBasicSalary()));
                row.add(cell);


                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getRealOvertimePay()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getOvertimePayG1()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getOvertimePayG2()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getOvertimePayG3()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getBirthdayCashgift()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getMerryCashgift()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getFuneralCashgift()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getFestivalCashgift()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getPreventHeatAllowance()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getHighTemperatureSubsidy()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getCommunicatySubsidy()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getShiftAllowance()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getStandAllowance()));
                row.add(cell);


                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getAchievementonus()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getAbroadInsuranceSubsidy()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getOtherItem1()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getOtherItem2()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getHouseSubsidy()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getSpecialAward()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getSignMoney()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getMeritsPay()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getAnnualBonus()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getOmpensation()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getAttendanceDeduction()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getOtherDeduction()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getTaxable()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getShouldSendTotal()));
                row.add(cell);


                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getCostWithhold()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getMealWithhold()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getEndowmentInsurance()));
                row.add(cell);


                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getMedicalInsurance()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getUnemploymentInsurance()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getHouseProvident()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getIndividualIncomeTax()));
                row.add(cell);

                cell = new HashMap<>();
                cell.put("value", Util.null2String(hrmSalaryEntity.getActuallySendTotal()));
                row.add(cell);

            }
            reportdata.put("datarows", datarows);
            apidatas.put("reportdata", reportdata);
            apidatas.put("fromDate", fromDate);
            apidatas.put("toDate", toDate);



        }catch (Exception e){
            e.printStackTrace();
        }
        return apidatas;
    }
}
